function T = householder(A)

n = max(size(A));

I = eye(n);
T = A;
for j=1:n-2
%     s = norm(T(j+1:n,j));
%     w = zeros(n,1);
%     w(j+1) = (s+abs(T(j+1,j)))/(2*s);
%     for k=j+2:n
%         w(k) = sign(T(j+1,j))*T(k,j)/(2*w(j+1)*s);
%     end

    alpha = -sign(T(j+1,j))*norm(T(j+1:n,j));
    r = sqrt(0.5*(alpha^2-T(j+1,j)*alpha));
    w = zeros(n,1);
    w(j+1) = (T(j+1,j)-alpha)/(2*r);
    for k=j+2:n
        w(k) = T(k,j)/(2*r);
    end
    
    P = I - 2*w*w';
    T = P'*A*P;
end